Take advantage of variable substitution already in the Makefile to specify the correc...
[asterisk/asterisk.git] / contrib / init.d / rc.redhat.asterisk
1 #!/bin/sh
2 # $Id$
3 #
4 # asterisk    Starts, Stops and Reloads Asterisk.
5 #
6 # chkconfig: 2345 90 60
7 # description: Asterisk PBX and telephony daemon.
8 # processname: asterisk
9 # pidfile: __ASTERISK_VARRUN_DIR__/asterisk.pid
10 #
11 # Thu Nov 17 2005 Gregory Boehnlein <damin@nacs.net>
12 # - Updated Version to 1.3
13 # - Reversed behavior of LD_ASSUME_KERNEL=2.4.1
14 # - Added detailed failure messages
15 #
16 # Sun Jul 18 2004 Gregory Boehnlein <damin@nacs.net>
17 # - Updated Version to 1.2
18 # - Added test for safe_asterisk
19 # - Verified SIGTERM issued by "killproc" ensures "stop gracefully"
20 # - Added support for -U and -G command line options
21 # - Modified "reload" to call asterisk -rx 'reload' 
22
23 ### BEGIN INIT INFO
24 # Provides:             asterisk
25 # Required-Start:    $network $syslog $named $local_fs $remote_fs
26 # Required-Stop:     $network $syslog $named $local_fs $remote_fs
27 # Should-Start:      dahdi misdn lcr wanrouter mysql postgresql
28 # Should-Stop:       dahdi misdn lcr wanrouter mysql postgresql
29 # Default-Start:        2 3 4 5
30 # Default-Stop:         0 1 6
31 # Short-Description:    Asterisk PBX
32 # Description:          the Asterisk Open Source PBX
33 ### END INIT INFO
34
35 # Use this option to specify a different configuration directory
36 #AST_CONFIG=__ASTERISK_ETC_DIR__
37
38 # Installation directory
39 AST_SBIN=__ASTERISK_SBIN_DIR__
40
41 # Source function library.
42 . /etc/rc.d/init.d/functions
43
44 if ! [ -x $AST_SBIN/asterisk ] ; then
45         echo "ERROR: $AST_SBIN/asterisk not found"
46         exit 0
47 fi
48
49 if ! [ -d $AST_CONFIG ] ; then
50         echo "ERROR: $AST_CONFIG directory not found"
51         exit 0
52 fi
53
54 # Full path to asterisk binary
55 DAEMON=$AST_SBIN/asterisk
56
57 # Full path to safe_asterisk script
58 SAFE_ASTERISK=$AST_SBIN/safe_asterisk
59
60 # Allow configuration overrides in /etc/sysconfig/asterisk
61 CONFIG0=`readlink $0`
62 if [ "$CONFIG0" = "" ]; then
63         CONFIGFILE=/etc/sysconfig/`basename $0`
64 else
65         CONFIGFILE=/etc/sysconfig/`basename $CONFIG0`
66 fi
67 [ -r $CONFIGFILE ] && . $CONFIGFILE
68
69 RETVAL=0
70
71 start() {
72         # Check if Asterisk is already running.  If it is, then bug out, because
73         # starting safe_asterisk when Asterisk is running is very bad.
74         VERSION=`${AST_SBIN}/asterisk -rx 'core show version'`
75         if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
76                 echo "Asterisk is already running."
77                 exit 1
78         fi
79
80         # Start daemons.
81         echo -n $"Starting asterisk: "
82         if [ -f $SAFE_ASTERISK ] ; then
83                 DAEMON=$SAFE_ASTERISK
84         fi
85         if [ $AST_USER ] ; then
86                 ASTARGS="-U $AST_USER"
87         fi
88         if [ $AST_GROUP ] ; then
89                 ASTARGS="$ASTARGS -G $AST_GROUP"
90         fi
91         if [ $AST_CONFIG ]; then
92                 ASTARGS="$ASTARGS -C $AST_CONFIG/asterisk.conf"
93         elif [ $ALTCONF ]; then
94                 ASTARGS="$ASTARGS -C $ALTCONF"
95         fi
96         if [ "x$COREDUMP" = "xyes" ]; then
97                 ASTARGS="$ASTARGS -g"
98         fi
99         if [ "0$MAXLOAD" -gt "0" ]; then
100                 ASTARGS="$ASTARGS -L $MAXLOAD"
101         fi
102         if [ "0$MAXCALLS" -gt "0" ]; then
103                 ASTARGS="$ASTARGS -M $MAXCALLS"
104         fi
105         if [ "0$VERBOSITY" -gt "0" ]; then
106                 for i in `seq 1 $VERBOSITY`; do
107                         ASTARGS="$ASTARGS -v"
108                 done
109         fi
110         if [ "x$INTERNALTIMING" = "xyes" ]; then
111                 ASTARGS="$ASTARGS -I"
112         fi
113         if [ "x$TEMPRECORDINGLOCATION" = "xyes" -o "x$TMPRECORDINGLOCATION" = "xyes" ]; then
114                 ASTARGS="$ASTARGS -t"
115         fi
116         if [ "x$COLOR" = "xyes" ]; then
117                 export TERM=linux
118                 daemon sh -c "$DAEMON $ASTARGS -c" >/dev/null </dev/null 2>&1 &
119         else
120                 daemon $DAEMON $ASTARGS
121         fi
122         RETVAL=$?
123         [ $RETVAL -eq 0 ] && touch /var/lock/subsys/asterisk
124         echo
125         return $RETVAL
126 }
127
128 stop() {
129         # Stop daemons.
130         if [ -f $SAFE_ASTERISK ]; then
131                 # Kill safe_asterisk first, to prevent us from starting up 2 instances of safe_asterisk
132                 echo -n $"Stopping safe_asterisk: "
133                 killproc `basename $SAFE_ASTERISK`
134                 echo
135         fi
136         echo -n $"Shutting down asterisk: "
137         killproc `basename $DAEMON`
138         RETVAL=$?
139         [ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/asterisk
140         echo
141         return $RETVAL
142 }
143
144 restart() {
145         stop
146         start
147 }
148
149 reload() {
150         $DAEMON -rx 'module reload' > /dev/null 2> /dev/null
151 }
152
153 # See how we were called.
154 case "$1" in
155   start)
156         start
157         ;;
158   stop)
159         stop
160         ;;
161   restart)
162         restart
163         ;;
164   reload)
165         reload
166         ;;
167   condrestart)
168         [ -f /var/lock/subsys/asterisk ] && restart || :
169         ;;
170   status)
171         status asterisk
172         ;;
173   *)
174         echo "Usage: asterisk {start|stop|restart|reload|condrestart|status}"
175         exit 1
176 esac
177
178 exit $?